## EMailSession

EMailSession

## Functions

EMailSession * | e_mail_session_new ()
ESourceRegistry * | e_mail_session_get_registry ()
MailFolderCache * | e_mail_session_get_folder_cache ()
CamelStore * | e_mail_session_get_local_store ()
CamelStore * | e_mail_session_get_vfolder_store ()
CamelFolder * | e_mail_session_get_local_folder ()
const gchar * | e_mail_session_get_local_folder_uri ()
GList * | e_mail_session_get_available_junk_filters ()
EMailJunkFilter * | e_mail_session_get_junk_filter_by_name ()
CamelFolder * | e_mail_session_get_inbox_sync ()
void | e_mail_session_get_inbox ()
CamelFolder * | e_mail_session_get_inbox_finish ()
CamelFolder * | e_mail_session_get_trash_sync ()
void | e_mail_session_get_trash ()
CamelFolder * | e_mail_session_get_trash_finish ()
CamelFolder * | e_mail_session_uri_to_folder_sync ()
void | e_mail_session_uri_to_folder ()
CamelFolder * | e_mail_session_uri_to_folder_finish ()
EMVFolderContext * | e_mail_session_create_vfolder_context ()
gboolean | e_binding_transform_service_to_source ()
gboolean | e_binding_transform_source_to_service ()
void | mail_session_flush_filter_log ()
const gchar * | mail_session_get_data_dir ()
const gchar * | mail_session_get_cache_dir ()
const gchar * | mail_session_get_config_dir ()

## Properties

MailFolderCache * | folder-cache | Read
CamelStore * | local-store | Read
ESourceRegistry * | registry | Read / Write / Construct Only
CamelStore * | vfolder-store | Read

## Signals

void | flush-outbox | Run First
void | refresh-service | Run Last
void | store-added | Run First
void | store-removed | Run First

## Types and Values

struct | EMailSession
#define | E_MAIL_SESSION_LOCAL_UID
#define | E_MAIL_SESSION_VFOLDER_UID
enum | EMailLocalFolder

## Object Hierarchy

        GObject
        ╰── CamelSession
            ╰── EMailSession

## Implemented Interfaces

EMailSession implements EExtensible.

## Description

## Functions

### e_mail_session_new ()

    EMailSession *
    e_mail_session_new (ESourceRegistry *registry);

### e_mail_session_get_registry ()

    ESourceRegistry *
    e_mail_session_get_registry (EMailSession *session);

### e_mail_session_get_folder_cache ()

    MailFolderCache *
    e_mail_session_get_folder_cache (EMailSession *session);

### e_mail_session_get_local_store ()

    CamelStore *
    e_mail_session_get_local_store (EMailSession *session);

### e_mail_session_get_vfolder_store ()

    CamelStore *
    e_mail_session_get_vfolder_store (EMailSession *session);

### e_mail_session_get_local_folder ()

    CamelFolder *
    e_mail_session_get_local_folder (EMailSession *session,
                                     EMailLocalFolder type);

### e_mail_session_get_local_folder_uri ()

    const gchar *
    e_mail_session_get_local_folder_uri (EMailSession *session,
                                         EMailLocalFolder type);

### e_mail_session_get_available_junk_filters ()

    GList *
    e_mail_session_get_available_junk_filters
                                   (EMailSession *session);

### e_mail_session_get_junk_filter_by_name ()

    EMailJunkFilter *
    e_mail_session_get_junk_filter_by_name
                                   (EMailSession *session,
                                    const gchar *filter_name);

Looks up an EMailJunkFilter extension by its filter name, as specified in its class structure. If no match is found, the function returns `NULL`.

#### Parameters

session | an EMailSession |
filter_name | a junk filter name |

#### Returns

an EMailJunkFilter, or `NULL`

### e_mail_session_get_inbox_sync ()

    CamelFolder *
    e_mail_session_get_inbox_sync (EMailSession *session,
                                   const gchar *service_uid,
                                   GCancellable *cancellable,
                                   GError **error);

### e_mail_session_get_inbox ()

    void
    e_mail_session_get_inbox (EMailSession *session,
                              const gchar *service_uid,
                              gint io_priority,
                              GCancellable *cancellable,
                              GAsyncReadyCallback callback,
                              gpointer user_data);

### e_mail_session_get_inbox_finish ()

    CamelFolder *
    e_mail_session_get_inbox_finish (EMailSession *session,
                                     GAsyncResult *result,
                                     GError **error);

### e_mail_session_get_trash_sync ()

    CamelFolder *
    e_mail_session_get_trash_sync (EMailSession *session,
                                   const gchar *service_uid,
                                   GCancellable *cancellable,
                                   GError **error);

### e_mail_session_get_trash ()

    void
    e_mail_session_get_trash (EMailSession *session,
                              const gchar *service_uid,
                              gint io_priority,
                              GCancellable *cancellable,
                              GAsyncReadyCallback callback,
                              gpointer user_data);

### e_mail_session_get_trash_finish ()

    CamelFolder *
    e_mail_session_get_trash_finish (EMailSession *session,
                                     GAsyncResult *result,
                                     GError **error);

### e_mail_session_uri_to_folder_sync ()

    CamelFolder *
    e_mail_session_uri_to_folder_sync (EMailSession *session,
                                       const gchar *folder_uri,
                                       CamelStoreGetFolderFlags flags,
                                       GCancellable *cancellable,
                                       GError **error);

### e_mail_session_uri_to_folder ()

    void
    e_mail_session_uri_to_folder (EMailSession *session,
                                  const gchar *folder_uri,
                                  CamelStoreGetFolderFlags flags,
                                  gint io_priority,
                                  GCancellable *cancellable,
                                  GAsyncReadyCallback callback,
                                  gpointer user_data);

### e_mail_session_uri_to_folder_finish ()

    CamelFolder *
    e_mail_session_uri_to_folder_finish (EMailSession *session,
                                         GAsyncResult *result,
                                         GError **error);

### e_mail_session_create_vfolder_context ()

    EMVFolderContext *
    e_mail_session_create_vfolder_context (EMailSession *session);

### e_binding_transform_service_to_source ()

    gboolean
    e_binding_transform_service_to_source (GBinding *binding,
                                           const GValue *source_value,
                                           GValue *target_value,
                                           gpointer session);

### e_binding_transform_source_to_service ()

    gboolean
    e_binding_transform_source_to_service (GBinding *binding,
                                           const GValue *source_value,
                                           GValue *target_value,
                                           gpointer session);

### mail_session_flush_filter_log ()

    void
    mail_session_flush_filter_log (EMailSession *session);

### mail_session_get_data_dir ()

    const gchar *
    mail_session_get_data_dir (void);

### mail_session_get_cache_dir ()

    const gchar *
    mail_session_get_cache_dir (void);

### mail_session_get_config_dir ()

    const gchar *
    mail_session_get_config_dir (void);

## Types and Values

### struct EMailSession

    struct EMailSession;

### E_MAIL_SESSION_LOCAL_UID

    #define E_MAIL_SESSION_LOCAL_UID   "local" /* "On This Computer" */

### E_MAIL_SESSION_VFOLDER_UID

    #define E_MAIL_SESSION_VFOLDER_UID "vfolder" /* "Search Folders" */

### enum EMailLocalFolder

#### Members

E_MAIL_LOCAL_FOLDER_INBOX |  |
E_MAIL_LOCAL_FOLDER_DRAFTS |  |
E_MAIL_LOCAL_FOLDER_OUTBOX |  |
E_MAIL_LOCAL_FOLDER_SENT |  |
E_MAIL_LOCAL_FOLDER_TEMPLATES |  |
E_MAIL_LOCAL_FOLDER_LOCAL_INBOX |  |
E_MAIL_NUM_LOCAL_FOLDERS |  |

## Property Details

### The `“folder-cache”` property

      “folder-cache”             MailFolderCache *

Flags: Read

### The `“local-store”` property

      “local-store”              CamelStore *

Built-in local store.

Flags: Read

### The `“registry”` property

      “registry”                 ESourceRegistry *

Data source registry.

Flags: Read / Write / Construct Only

### The `“vfolder-store”` property

      “vfolder-store”            CamelStore *

Built-in search folder store.

Flags: Read

## Signal Details

### The `“flush-outbox”` signal

    void
    user_function (EMailSession *session,
                   gpointer      user_data)

Emitted if the send folder should be flushed.

#### Parameters

session | the email session |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“refresh-service”` signal

    void
    user_function (EMailSession *session,
                   CamelService *service,
                   gpointer      user_data)

Emitted when `service` should be refreshed.

#### Parameters

session | the EMailSession that emitted the signal |
service | a CamelService |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“store-added”` signal

    void
    user_function (EMailSession *session,
                   CamelStore   *store,
                   gpointer      user_data)

Emitted when a store is added

#### Parameters

session | the EMailSession that emitted the signal |
store | a CamelStore |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“store-removed”` signal

    void
    user_function (EMailSession *session,
                   CamelStore   *store,
                   gpointer      user_data)

Emitted when a store is removed

#### Parameters

session | the EMailSession that emitted the signal |
store | a CamelStore |
user_data | user data set when the signal handler was connected. |

Flags: Run First